#!/bin/env python

import ldap, os, sys, time

server = 'ldap://ldap.myserver.org:389'
dnbase = 'dc=ssh,dc=myserver,dc=org'
dnuser = 'cn=manager,dc=myserver,dc=org'
dnpass = 'sshfed.666'
domainURN = 'es:rediris.es'
oldfiles = False;
sshserver = 'node01.myserver.org'
sshport = '22'
users = [['perfsonar','/home/perfsonar/'], ['root','/root/']]

l = ldap.initialize(server)
try:
	l.simple_bind_s(dnuser, dnpass)
	for data_users in users:
		keys = []
		filter = '(&(objectClass=ldapPublicKey)(schacUserStatus=urn:mace:terena.org:schac:userStatus:' + domainURN + ':sshaccess:' + sshserver + '%3A' + sshport + '*user=' + data_users[0] + '))'
		result_id = l.search(dnbase, ldap.SCOPE_ONELEVEL, filter, ["sshPublicKey", "schacExpiryDate"])
		while 1:
			result_type, result_data = l.result(result_id, 0)
			if result_data == []:
				break;
			elif result_type == ldap.RES_SEARCH_ENTRY:
				for i in range(len(result_data)):
					expiryTime = result_data[i][1]["schacExpiryDate"][0]
					expiryTS = time.strptime(expiryTime, "%Y%m%d%H%M%SZ")
					nowTS = time.gmtime();
					if expiryTS > nowTS:
						keys.append(result_data[i][1]["sshPublicKey"][0])
		filename = data_users[1] + ".ssh/authorized_keys"
		if oldfiles == True:
			filename = data_users[1] + ".ssh/authorized_keys2"
		fd = open(filename,"w")
		fd.write("#####" + "\n")
		for key in keys:
			fd.write(key + "\n")
		fd.close()
	
except ldap.INVALID_CREDENTIALS:
	print "User or password is incorrect."
	sys.exit()

except ldap.LDAPError, e:
	if type(e.message) == dict and e.message.has_key('desc'):
		print e.message['desc']
	else:
		print e
	sys.exit()

l.unbind()

